version: '3'
# this compose should be used only for dev env !
# if not the service in development should be updated
services:
  gateway:
    hostname: gateway
    container_name: gateway
    image: traefik:1.7
    command: --api --docker
    ports:
      - 8080:8080
      - 80:80
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock  # listen docker
    restart: always

  user:
    hostname: user
    image: registry.gitlab.com/workkaylleur/user-service:develop
    environment:
      - NODE_ENV=development
    restart: always
    depends_on:
      - mongo
      - gateway
      - workspace
    labels:
      - "traefik.frontend.rule=PathPrefix:/api/users,/api/roles,/api/privileges"
    ports:
      - 3001:3000
  #    volumes:
  #      - ./src:/opt/app/src
  #      - ./config:/opt/app/config
  #      - ./types:/opt/app/types
  #      - ./package.json:/opt/app/package.json

  workspace:
    hostname: workspace
    image: registry.gitlab.com/workkaylleur/workspaceservice:develop
    environment:
      - NODE_ENV=development
    depends_on:
      - mongo
    restart: always
    labels:
      - "traefik.frontend.rule=PathPrefix:/api/workspaces"
    ports:
      - 3002:3000

  notification:
    hostname: notification
    image: registry.gitlab.com/workkaylleur/notificationservice:develop
    environment:
      - NODE_ENV=development
    depends_on:
      - mongo
      - user
      - amqp
    restart: always
    labels:
      - "traefik.frontend.rule=PathPrefix:/api/notifications,/api/notifications-types"
    ports:
      - 3004:3000

  event:
    hostname: event
    image: registry.gitlab.com/workkaylleur/eventservice:develop
    environment:
      - NODE_ENV=development
    depends_on:
      - mongo
      - user
      - amqp
      - redis
      - workspace
    restart: always
    labels:
      - "traefik.frontend.rule=PathPrefix:/api/events"
    ports:
      - 3005:3000

  proxy:
    hostname: proxy
    image: registry.gitlab.com/workkaylleur/proxyservice:develop
    environment:
      - NODE_ENV=development
    depends_on:
      - user
      - workspace
    restart: always
    labels:
      - "traefik.frontend.rule=PathPrefix:/api/proxy"
    ports:
      - 3006:3000

  # Mongo replica set
  mongo:
    hostname: mongo
    container_name: mongo
    image: mongo:4
    restart: always
    labels:
      - "traefik.enable=false"
    ports:
      - 27018:27017

  nginx:
    hostname: nginx
    container_name: nginx
    image: nginx:1
    volumes:
      - ./default.conf:/etc/nginx/nginx.conf
    ports:
      - 8082:80
    restart: always
    depends_on:
      - front
    labels:
      - "traefik.enable=false"

  amqp:
    hostname: amqp
    container_name: amqp
    image: rabbitmq:management-alpine
    ports:
      - 15672:15672
      - 5672:5672
    environment:
      - RABBITMQ_DEFAULT_USER=guest
      - RABBITMQ_DEFAULT_PASS=guest
  redis:
    hostname: redis
    container_name: redis
    image: redis:alpine
    ports:
      - 6379:6379

  front:
    hostname: front
    container_name: front
    image: containous/whoami
    depends_on:
      - gateway
    labels:
      - "traefik.enable=true"
    ports:
      - 8081:80
